import { gcodeSyntax } from "../gcode";
import { EditorState } from '@codemirror/next/basic-setup';
function verify(s, config) {
    const diagnostics = new Array();
    const start = new Date();
    const tree = gcodeSyntax.parser.parse(s, { strict: false });
    console.log('Parse took: ' + (new Date().getMilliseconds() - start.getMilliseconds()) + 'ms');
    // console.log(tree.toString());
    tree.iterate({
        from: 0,
        to: tree.length,
        enter: (type, start, end) => {
            // console.log(type.name, type.name.charCodeAt(0), start, end);
            // if (type.id === 0)
            if (type.name.charCodeAt(0) === 9888) {
                console.log('found error', type.name, type.name.charCodeAt(0), start, end);
                // error.severity = 'error';
                // error.from = start;
                // error.to = end;
                // error.message = 'Syntax Error: Invalid character.';
                // error.actions = [{
                //     name: "fix",
                //     apply(view: EditorView, start: number, end: number) {
                //         view.dispatch(
                //             {
                //                 changes: {
                //                     from: start,
                //                     to: end,
                //                     insert: ''
                //                 },
                //                 scrollIntoView: true
                //             })
                //     }
                // }];
                // diagnostics.push(error);
            }
        }
    });
    return diagnostics;
}
export function gcodeLinter(config) {
    function range(state, from = 0, to = state.doc.length) {
        return verify(state.sliceDoc(from, to), config);
    }
    return (view) => {
        const [syntax] = view.state.facet(EditorState.syntax);
        const found = [];
        // FIXME move to async parsing?
        syntax.getTree(view.state).iterate({
            enter(type, from, to) {
                if (type.name == gcodeSyntax.parser.topType.name) {
                    for (const diagnostic of range(view.state, from, to)) {
                        found.push(diagnostic);
                    }
                    return false;
                }
            }
        });
        return found;
    };
}
//# sourceMappingURL=gcode-linter.js.map