
import chai from 'chai';
import {Parser} from "./parser";
import {createEditorState} from "../../test/utils";

describe('Program', () => {
    const tests = [
        {
            title: 'Start of program',
            doc: '%' +
                '%',
            expectedDiagnosis: []
        }
    ];

    tests.forEach(test => {
        const editorState = createEditorState(test.doc);
        const parser = new Parser(editorState);
        it(test.title, () => {
            parser.check(editorState.tree.topNode);
            chai.expect(parser.getDiagnostics()).to.deep.equal(test.expectedDiagnosis);
        })
    })

   // it('should start with a %', () => {
   //
   // }) ;
});
