import { Diagnostic } from '@codemirror/next/lint';
import { EditorState } from '@codemirror/next/basic-setup';


export class Parser {

    private readonly diagnostics: Diagnostic[];
    private readonly state: EditorState;
    private readonly tree;

    constructor(editorState: EditorState) {
        this.diagnostics = new Array<Diagnostic>();
        this.tree = editorState.tree;
        this.state = editorState;
    }

    check(node) {
        // console.log(node);

    }

    getDiagnostics(): Diagnostic[] {
        return this.diagnostics;
    }

    private addDiagnostic(node, msg: string): void {
        this.diagnostics.push({
            severity: 'error',
            message: msg,
            from: node.start,
            to: node.end,
        });
    }

}
